#include "descriptor/descriptor.h"

int main(void)
{
	/*TEXTURE*/
	char * tex_marmo = "textures/wood.hr";
	char * tex_bump = "textures/wood_bump.hr";
	char * tex_ripiano = "textures/ripiano.hr";
	char * tex_cornice = "textures/cornice.hr";
	char * tex_tela1 = "textures/cena.hr";
	char * tex_tela2 = "textures/nottestellata.hr";
	char * tex_tela3 = "textures/rgb.hr";

	ITEM	white, metalblack, grass, glass, cotto, marrone, azzurro, ceramic, pav_color, brown,  black,
			blu_plastic, copper, ink;
	ITEM	testa_coccodrillo, lamp, foglio1, foglio2;
	ITEM	biro_corpo,biro_mina,biro_tappo,biro_punta;
	ITEM	pavimento,stanza,battiscopa;
	ITEM	quadro1,quadro2,tela1,tela2;
	ITEM	sedia,sedia_schienale;
	ITEM	table,table_ripiano;
	ITEM	pianta,pianta_vaso,pianta_terra,pianta_bastone;
	ITEM	pianta2,pianta_vaso2,pianta_terra2,pianta_bastone2;

	ITEM	scene;

	set_background(0.676,0.861,0.953,TRUE);
	set_ambient_light(1,1,1,0.7);
	create_point_light(3.635,8.775,5.221,1,1,1,1.0,20, "light1");
	create_point_light(0.503,1.8020,0.994,1,1,1,2.0,4, "lampada");
	/*
		ATTRIBUTI
	*/
	/*** ATTRIBUTE azurro ***/
	blu_plastic = create_attribute("blu_plastic");
		set_color(blu_plastic,0.0,0.0,1,0.56,0.5);
		set_reflectivity(blu_plastic,0.2,2);

		/*** ATTRIBUTE azurro ***/
	copper = create_attribute("copper");
		set_color(copper,0.707,0.472,0.253,0.5,0.5);
		set_reflectivity(copper,0.1,2);

	ink = create_attribute("grafite");
		set_color(ink,0,0,0.535,0,0);

	/*** ATTRIBUTE azurro ***/
	glass = create_attribute("glass");
		set_color(glass,0.68,0.86,1,0.5,0.5);
		set_reflectivity(glass,0.15,2);
		set_transparency(glass,0.87,0.68,2,1.520);

	/*** ATTRIBUTE azurro ***/
	azzurro = create_attribute("azzurro");
		set_color(azzurro,0.68,0.86,1,0.5,0.5);

	/*** ATTRIBUTE marrone ***/
	marrone = create_attribute("marrone");
		set_color(marrone,0.537,0.349,0.270,0.5,0.5);

	white = create_attribute("bianco");
		set_color(white,1,1,1,0.5,0.5);

	/*** ATTRIBUTE cotto ***/
	cotto = create_attribute("cotto");
		set_color(cotto,0.596,0.231,0.0,0.65,0.391);

	/*** ATTRIBUTE pavimento ***/
	pav_color = create_attribute("pav_color");
		set_color(pav_color,1,1,1,0.790,0.350);
		set_reflectivity(pav_color,0.3,2);

	/*** ATTRIBUTE ceramic ***/
	ceramic = create_attribute("ceramic");
		set_color(ceramic,0.89,0.76,0.65,0.15,0.350);
		set_reflectivity(ceramic,0.06,2);

	/*** ATTRIBUTE brown ***/
	brown = create_attribute("brown");
		set_color(brown,0.93,0.23,0.03,0.2,0.8);
		set_reflectivity(brown,0.17,2);

 	/*** ATTRIBUTE grass ***/
	grass = create_attribute("grass");
		set_color(grass,0.098,0.325,0.172,0.5,0.6);

	/*** ATTRIBUTE black ***/
	black = create_attribute("black");
		set_color(black,0.0,0.0,0.0,0.5,0.5);
		set_reflectivity(black,0.2,10);

	/*** ATTRIBUTE metal_black ***/
	metalblack = create_attribute("metal_black");
		set_color(metalblack,0.0,0.0,0.0,0.8,0.8);
		set_reflectivity(metalblack,0.05,2);
		set_transparency(metalblack,0.0,0.0,0.0,2.0);

	/*
		OGGETTI
	*/

/*** Coccodrillo ***/
	testa_coccodrillo = read_obj("coccodrillo_t.obj", "testa_coccodrillo");
	/*Positioning*/
		set_scale(testa_coccodrillo, 0.5, 0.5, 0.5);
		set_z_rotate(testa_coccodrillo,45.0, 1);
		set_translate(testa_coccodrillo,0.8,-0.8,0.05);
		set_attribute(testa_coccodrillo,glass);

/*** Tavolo ***/
	table = read_obj("tavolo_t.obj","tavolo");
	/*Positioning*/
		set_attribute(table,ceramic);
		set_z_rotate(table,180, 1);
		set_translate(table,0.0,1.5,-1.2);

	table_ripiano = read_nurbs("ripiano.db");
	/*Positioning*/
		set_projection_texture(table_ripiano,ceramic,tex_ripiano,1,1,0.4,0.5);
		set_attribute(table_ripiano,ceramic);
		set_z_rotate(table_ripiano,180, 1);
		set_translate(table_ripiano,0.0,1.5,-1.2);

/*** Quadro 1 ***/
	quadro1 = read_obj("quadro.obj","quadro");
	/*Texturing*/
		set_projection_texture(quadro1,marrone,tex_cornice,1,1,0.4,0.5);
	/*Positioning*/
		set_y_rotate(quadro1,90, 1);
		set_scale(quadro1, 0.5, 0.5, 0.5);
		set_translate(quadro1,-4.99,5.0,3.0);
		set_attribute(quadro1,brown);

/*** Quadro 2 ***/
	quadro2 = create_copy(quadro1, "quadro2");
	/*Positioning*/
		set_x_rotate(quadro2,90,1);
		set_scale(quadro2, 0.6, 0.6, 0.6);
		set_translate(quadro2,-2.0,3.0,-0.5);


/*** Tela Quadro 1 - 2 ***/
	tela1 = read_nurbs("quadro_tela.db");
	tela2 = create_copy(tela1, "tela1");

/*** Tela Quadro 1 ***/
	/*Texturing*/
		set_scale(tela1, 0.65, 0.5, 0.7);
		set_translate(tela1,0.35,0.0,0);
		set_z_rotate(tela1,270, 1);
		set_projection_texture(tela1,black,tex_tela3,2,0,0.4,0.5);
		set_z_rotate(tela1,-270, 1);
		set_translate(tela1,-0.35,0.0,0);
		set_scale(tela1, 1.0/0.65, 1.0/0.5, 0.7);
	/*Positioning*/
		set_y_rotate(tela1,90, 1);
		set_scale(tela1, 0.5, 0.5, 0.5);
		set_translate(tela1,-4.99,5.0,3.0);
		set_attribute(tela1,black);

/*** Tela Quadro 2 ***/
	/*Texturing*/
		set_scale(tela2, 0.65, 0.5, 0.7);
		set_translate(tela2,0.35,0.0,0);
		set_projection_texture(tela2,black,tex_tela2,2,0,0.4,0.5);
		set_translate(tela2,-0.35,0.0,0);
		set_scale(tela2, 1.0/0.65, 1.0/0.5, 1.0/0.7);
	/*Positioning*/
		set_y_rotate(tela2,90, 1);
		set_scale(tela2, 0.5, 0.5, 0.5);
		set_translate(tela2,-4.99,5.0,3.0);
		set_attribute(tela2,black);
		set_x_rotate(tela2,90,1);
		set_scale(tela2, 0.6, 0.6, 0.6);
		set_translate(tela2,-2.0,3.0,-0.5);

/*** Stanza ***/
	stanza = read_obj("stanza.obj","stanza");
		/*Positioning*/
		set_scale(stanza, 10.0, 10.0, 7.0);
		set_translate(stanza,5.0,8.4,4.58);
		set_attribute(stanza,azzurro);

/*** Battiscopa ***/
	battiscopa = read_nurbs("battiscopa.db");
	/*Positioning*/
		set_scale(battiscopa, 10.0, 10.0, 7.0);
		set_translate(battiscopa,5.0,8.4,4.58);
		set_attribute(battiscopa,marrone);

/*** Pavimento ***/
	pavimento = read_nurbs("pavimento.db");
	/*Texturing*/
		set_scale(pavimento, 8.0, 8.0, 1);
		set_translate(pavimento,0.5,0.5,1.5);
		set_bump_texture(pavimento, pav_color,tex_bump, 0, 0.09,0, 0.09, 1,0.6, 0.8);
		set_translate(pavimento,-0.5,-0.5,-1.5);
		set_scale(pavimento, 1.0/8.0, 1.0/8.0, 1);
	/*Positioning*/
		set_scale(pavimento, 10.0, 10.0, 7.0);
		set_translate(pavimento,5.0,8.4,4.7);

/*** Lampada ***/
	lamp = read_obj("lampada.obj","lamp");
	/*Positioning*/
		set_z_rotate(lamp,140,1);
		set_translate(lamp,1.3,2.0,1.50);
		set_attribute(lamp,black);

/*** Pianta ***/
	pianta = read_obj("vaso_t.obj","pianta");
	pianta2 = create_copy(pianta, "pianta2");
	/*Positioning*/
		set_scale(pianta,1.5,1.5,1.5);
		set_translate(pianta,-3.0,6.0,-1.8);
		set_attribute(pianta,grass);

	pianta_terra = read_nurbs("vaso_terra.db");
	pianta_terra2 = create_copy(pianta_terra, "pianta_terra2");
	/*Positioning*/
		set_scale(pianta_terra,1.5,1.5,1.5);
		set_translate(pianta_terra,-3.0,6.0,-1.8);
		set_attribute(pianta_terra,marrone);

	pianta_vaso = read_nurbs("vaso_vaso.db");
	pianta_vaso2 = create_copy(pianta_vaso, "pianta_vaso2");
	/*Positioning*/
		set_scale(pianta_vaso,1.5,1.5,1.5);
		set_translate(pianta_vaso,-3.0,6.0,-1.8);
		set_attribute(pianta_vaso,cotto);

	pianta_bastone = read_nurbs("vaso_bastone.db");
	pianta_bastone2 = create_copy(pianta_bastone, "pianta_bastone2");
	/*Positioning*/
		set_scale(pianta_bastone,1.5,1.5,1.5);
		set_translate(pianta_bastone,-3.0,6.0,-1.8);
		set_attribute(pianta_bastone,marrone);

/*** Pianta2 ***/
		float x,y,z;
		x = 3.0;
		y = -0.4;
		z = -2.0;
		set_translate(pianta2,x,y,z);
		set_attribute(pianta2,grass);
	/*Positioning*/
		set_attribute(pianta_terra2,marrone);
		set_translate(pianta_terra2,x,y,z);
	/*Positioning*/
		set_attribute(pianta_bastone2,marrone);
		set_translate(pianta_bastone2,x,y,z);
	/*Positioning*/
		set_attribute(pianta_vaso2,cotto);
		set_translate(pianta_vaso2,x,y,z);

/*** Sedia ***/
	sedia = read_obj("sedia_t.obj", "sedia");
	/*Positioning*/
		set_scale(sedia,0.25,0.25,0.25);
		set_z_rotate(sedia,90,1);
		set_translate(sedia,-4.0,1.5,-1.15);
		set_attribute(sedia,metalblack);

	sedia_schienale = read_nurbs("sedia_schienale.db");
	/*Positioning*/
		set_scale(sedia_schienale,0.25,0.25,0.25);
		set_z_rotate(sedia_schienale,90,1);
		set_translate(sedia_schienale,-4.0,1.5,-1.15);
		set_attribute(sedia_schienale,brown);

/*** Penna ***/
	biro_corpo = read_nurbs("biro_corpo.db");
	/*Positioning*/
		set_x_rotate(biro_corpo,90,1);
		set_z_rotate(biro_corpo,40,1);
		set_translate(biro_corpo,-0.6,1.3,-0.075);
	/*Texturing*/
		set_attribute(biro_corpo,glass);

	biro_mina = read_nurbs("biro_mina.db");
	/*Positioning*/
		set_x_rotate(biro_mina,90,1);
		set_z_rotate(biro_mina,40,1);
		set_translate(biro_mina,-0.6,1.3,-0.075);
	/*Texturing*/
		set_attribute(biro_mina,ink);

	biro_tappo = read_nurbs("biro_tappo.db");
	/*Positioning*/
		set_x_rotate(biro_tappo,90,1);
		set_z_rotate(biro_tappo,40,1);
		set_translate(biro_tappo,-0.6,1.3,-0.075);
	/*Texturing*/
		set_attribute(biro_tappo,blu_plastic);

	biro_punta = read_nurbs("biro_punta.db");
	/*Positioning*/
		set_x_rotate(biro_punta,90,1);
		set_z_rotate(biro_punta,40,1);
		set_translate(biro_punta,-0.6,1.3,-0.075);
	/*Texturing*/
		set_attribute(biro_punta,copper);


/*** Foglio1 ***/
	foglio1 = read_nurbs("foglio.db");
	/*Positioning*/
		set_x_rotate(foglio1,90,1);
		set_scale(foglio1,0.8,0.8,0.8);
		set_translate(foglio1,1.0,0.7,-0.099);
		set_z_rotate(foglio1,90,1);
		set_attribute(foglio1,white);

/*** Foglio2 ***/
	foglio2 = create_copy(foglio1,"foglio2");
		set_z_rotate(foglio2,30,1);
		set_translate(foglio2,0.7,0.0,0.0);

	/*
		CREAZIONE LISTA
	*/
	scene = create_list(testa_coccodrillo, "scene");
	scene = insert_in_list(scene,sedia);
	scene = insert_in_list(scene,sedia_schienale);
	scene = insert_in_list(scene,table);
 	scene = insert_in_list(scene,table_ripiano);
	scene = insert_in_list(scene,lamp);
	scene = insert_in_list(scene,stanza);
	scene = insert_in_list(scene,foglio1);
	scene = insert_in_list(scene,foglio2);
	scene = insert_in_list(scene,biro_corpo);
	scene = insert_in_list(scene,biro_mina);
	scene = insert_in_list(scene,biro_tappo);
	scene = insert_in_list(scene,biro_punta);
	scene = insert_in_list(scene,pianta);
	scene = insert_in_list(scene,pianta_terra);
	scene = insert_in_list(scene,pianta_bastone);
	scene = insert_in_list(scene,pianta_vaso);

	scene = insert_in_list(scene,pianta2);
	scene = insert_in_list(scene,pianta_terra2);
	scene = insert_in_list(scene,pianta_bastone2);
	scene = insert_in_list(scene,pianta_vaso2);

	scene = insert_in_list(scene,battiscopa);
	scene = insert_in_list(scene,pavimento);
	scene = insert_in_list(scene,tela1);
	scene = insert_in_list(scene,tela2);
	scene = insert_in_list(scene,quadro1);
	scene = insert_in_list(scene,quadro2);


	save_scene("scena.md","scene",scene);

	return(0);
}
